#include <stdio.h>
#include <stdlib.h>
#include <cbm.h>
#include <conio.h>
#include <errno.h>

#define SCREEN_RAM ((unsigned char *)0x0400)

#define CH_RVS_ON   18
#define CH_RVS_OFF 146

struct colors {
  char border;
  char background;
  char text;
};

/* declarations */
int ul=4*40+12; /*offset from upper left of screen */

int set_colors(unsigned char border, unsigned char background,
	       unsigned char text) {
  *(unsigned char *)(53280L) = border;
  *(unsigned char *)(53281L) = background;
  *(unsigned char *)(  646L) = text;

  return 0;
}

int colormenu(unsigned char *pborder, unsigned char *pback,
	      unsigned char *ptext) {
  int done=0;
  int device=8;
  int c, i;
  int current;
  unsigned char colorarray[3];
  int ea, eb;
  
  do {
    clrscr();
    putchar(CH_FONT_UPPER);
    printf("\n");
    printf("\n");
    putchar(CH_RVS_ON);
    current=textcolor(0);
    for (i=0; i<16; i++) {
      textcolor(i);
      printf("          ");
    };
    putchar(CH_RVS_OFF);
    textcolor(current);
    printf("\n");
    printf("\n");
    printf("                colors\n");
    printf("                ");
    for (i=0; i<6; i++)
      putchar(CH_HLINE);
    printf("\n");
    printf("\n");
    printf("          (b)order    : %02d\n", *pborder);
    printf("          bac(k)ground: %02d\n", *pback);
    printf("          (t)ext      : %02d\n", *ptext);
    printf("          (d)evice    : %02d\n", device);
    printf("          (i)nitialize device\n");
    printf("          (l)oad colors\n");
    printf("          (s)ave colors\n");
    printf("          d(e)faults\n");
    printf("          e(x)it menu\n");
    c=cgetc();
    switch (c) {
    case 'b':
      *pborder=(*pborder+1)&15;
      break;
    case 'k':
      *pback=(*pback+1)&15;
      if (*pback==*ptext) /* text and background should not be the same */
	*pback=(*pback+1)&15;
      break;
    case 't':
      *ptext=(*ptext+1)&15;
      if (*pback==*ptext) /* text and background should not be the same */
	*ptext=(*ptext+1)&15;
      break;
    case 'd':
      device++;
      if (device>11)
	device=1;
      if (device==3)
	device++;
      break;
    case 'i':
      cbm_open(15, device, 15, "i");
      cbm_close(15);
      break;
    case 'l':
      ea=cbm_open(2, device, CBM_READ, "colors,u");
      /* cbm_open returns 0 on success or fail */
      eb=cbm_read(2, colorarray, 3);
      cbm_close(2);
      if (eb<3) { /* cbm_read should return 3 on success */
	/* initialize drive */
	cbm_open(15, device, 15, "i");
	cbm_close(15);
	break;
      }

      set_colors(colorarray[0], colorarray[1], colorarray[2]);
      *pborder = colorarray[0];
      *pback   = colorarray[1];
      *ptext   = colorarray[2];
      break;
    case 's':
      colorarray[0] = *pborder;
      colorarray[1] = *pback;
      colorarray[2] = *ptext;
      cbm_open(2, device, CBM_WRITE, "@0:colors,u");
      cbm_write(2, colorarray, 3);
      cbm_close(2);
      break;
    case 'x':
      done=1;
      break;
    case 'e':
      *pborder=COLOR_BLUE;
      *pback=COLOR_BLUE;
      *ptext=COLOR_GRAY3;
      break;
    };
    set_colors(*pborder, *pback, *ptext);
  } while (!done);
  return 0;
}

int init_colors(void) {
  unsigned char border=COLOR_BLUE;
  unsigned char background=COLOR_BLUE;
  unsigned char text=COLOR_GRAY3;

  int c;

  clrscr();
  printf("\nUse default colors?");
  c=cgetc();
  if (c=='n') {
    colormenu(&border, &background, &text);
    /*
    printf("bord,back,text %d,%d,%d\n",border,background,text);
    cgetc();
    */
  }
  set_colors(border, background, text);
  return 0;
}

int init_draw(int linecolor) {
  int i;

  clrscr();

  putchar(CH_FONT_UPPER);
  printf("             magic squares\n\n");
  printf(" copyright 2021     michael j. chappell\n");
  
  for (i=160; i<=175; i++) {
    SCREEN_RAM[ul+i]=160;
    COLOR_RAM[ul+i]=linecolor;
    SCREEN_RAM[ul+i+240]=160;
    COLOR_RAM[ul+i+240]=linecolor;
  }
  for (i=4; i<=604; i+=40) {
    SCREEN_RAM[ul+i]=160;
    COLOR_RAM[ul+i]=linecolor;
    SCREEN_RAM[ul+i+6]=160;
    COLOR_RAM[ul+i+6]=linecolor;
  }

  return 0;
}

int drawdigit(digit, lit) {
  /* position rel to upper left for digit */
  int position[] = { 0, 480, 486, 492, 240, 246, 252, 0, 6, 12 };

  /* half diag shaded chars and solid block */
  unsigned char nw=233, ne=223, sw=95, se=105, bl=160;

  int color, offset;

  color = lit?COLOR_RED:COLOR_LIGHTBLUE;
  offset = position[digit]+ul;

  SCREEN_RAM[offset   ]=nw;
  SCREEN_RAM[offset+ 1]=bl;
  SCREEN_RAM[offset+ 2]=ne;
  SCREEN_RAM[offset+40]=bl;
  SCREEN_RAM[offset+41]=digit+176;
  SCREEN_RAM[offset+42]=bl;
  SCREEN_RAM[offset+80]=sw;
  SCREEN_RAM[offset+81]=bl;
  SCREEN_RAM[offset+82]=se;

  COLOR_RAM[offset   ]=color;
  COLOR_RAM[offset+ 1]=color;
  COLOR_RAM[offset+ 2]=color;
  COLOR_RAM[offset+40]=color;
  COLOR_RAM[offset+41]=color;
  COLOR_RAM[offset+42]=color;
  COLOR_RAM[offset+80]=color;
  COLOR_RAM[offset+81]=color;
  COLOR_RAM[offset+82]=color;

 return 0;
}

int drawboard(int board, int moves) {
  int test=1;
  int digit;

  for (digit=1; digit<=9; digit++) {
    drawdigit(digit, board&test);
    test=test<<1;
  }
  gotoxy(34,4);
  printf("moves");
  gotoxy(34,6);
  printf(" %3d",moves);
  
  return 0;
}

int game() {
  int q=0;
  int quit=0;
  int moves;

  int win=495;
  int board;
  int mask;

  int c;

  _randomize();
  do {
    board = rand() % 512;
  } while (board == win); /* if win generated, try another rnd number */
  moves = 0;

  init_draw(COLOR_BLACK);
  
  while (!quit) {
    drawboard(board, moves);
    if (board==win)
      break;
    gotoxy(0,21);
    printf("    select 1-9, (q)uit or (r)efresh\n");
    /*    printf("moves %d, board %d %x", moves, board, board); */
    c=cgetc();

    switch (c) {
    case 'q':
      mask=0;
      quit=1;
      break;
    case 'r':
      mask=0;
      init_draw(COLOR_BLACK);
      break;
    case '1':
      mask=0x01b;
      moves++;
      break;
    case '2':
      mask=0x007;
      moves++;
      break;
    case '3':
      mask=0x036;
      moves++;
      break;
    case '4':
      mask=0x049;
      moves++;
      break;
    case '5':
      mask=0x0ba;
      moves++;
      break;
    case '6':
      mask=0x124;
      moves++;
      break;
    case '7':
      mask=0x0d8;
      moves++;
      break;
    case '8':
      mask=0x1c0;
      moves++;
      break;
    case '9':
      mask=0x1b0;
      moves++;
      break;
    default:
      break;
    }
    board = board^mask;
  }
  if (quit)
    moves = -1*moves;

  return moves;
}

int main() {
  struct colors old;
  
  int moves;
  int c;
  int again=1;

  old.border     = (* (unsigned char *)(53280L));
  old.background = (* (unsigned char *)(53281L));
  old.text       = (* (unsigned char *)(  646L));

  init_colors();

  while (again) {
    moves = game();
    if (moves<1) {
      clrscr();
      printf("\nyou quit after %d moves.\n\n",-1*moves);
      printf("bye!\n\n");
      again = 0;
    } else {
      gotoxy(0,21);
      printf("                                       ");
      gotoxy(0,21);
      printf("          you won in %d moves!         ", moves);
      gotoxy(0,23);
      printf("      < press any key to continue >");
      c=cgetc();
      clrscr();
      printf("\nwould you like to play again?");
      c=cgetc();
      again = (c!='n'); /* must choose n to quit */
    }
  };

  set_colors(old.border, old.background, old.text);

  return EXIT_SUCCESS;
}
